//============================================================================
// CFA-634 Ultra simple command line test demonstration program
// Copyright (c) 2001-2005, Crystalfontz America, Inc.
// http://www.crystalfontz.com
//============================================================================
#include "stdafx.h"
#include "serial.h"
//------------------------------------------------------------------------------
const char
	*serial_port_names[9]=
   {"COM1","COM2","COM3","COM4","COM5","COM6","COM7","COM8","COM9"};
//------------------------------------------------------------------------------
HANDLE
  hCom=NULL;
//------------------------------------------------------------------------------
int Serial_Init(int port, int baud_rate)
	{
	DCB
		dcb;
	BOOL
		fSuccess;

	if(hCom)
		CloseHandle(hCom);

	hCom = CreateFile(
		serial_port_names[port],
		GENERIC_READ | GENERIC_WRITE,
		0,             /* comm devices must be opened w/exclusive-access */
		NULL,          /* no security attrs */
		OPEN_EXISTING, /* comm devices must use OPEN_EXISTING */
		0,             /* not overlapped I/O */
		NULL           /* hTemplate must be NULL for comm devices */
		);

	if(hCom == INVALID_HANDLE_VALUE)
    {
    hCom=0;
		return(1);
    }

	/*
	 * Omit the call to SetupComm to use the default queue sizes.
	 * Get the current configuration.
	 */
	fSuccess = GetCommState(hCom, &dcb);
	if(!fSuccess)
    {
    hCom=0;
		return(2);
    }

  int
    baud_rates[8]=
      {1200,2400,4800,9600,19200,38400,57600,115200};

	/* Fill in the DCB: baud=9600, 8 data bits, no parity, 1 stop bit. */
	dcb.BaudRate = baud_rates[baud_rate];
	dcb.ByteSize = 8;
	dcb.Parity = NOPARITY;
	dcb.StopBits = ONESTOPBIT;
	dcb.fRtsControl = RTS_CONTROL_ENABLE; //needed to power from port
	dcb.fDtrControl = DTR_CONTROL_ENABLE; //needed to power from port
	dcb.fAbortOnError = FALSE; 
	fSuccess = SetCommState(hCom, &dcb);

	if(!fSuccess)
    {
    hCom=0;
		return(3);
    }

	return(0);
	}
//------------------------------------------------------------------------------
void Uninit_Serial()
  {
	CloseHandle(hCom);
	hCom=NULL;
  }
//------------------------------------------------------------------------------
void SendByte(unsigned char datum)
	{
	DWORD
		bytes_written;
	bytes_written=0;

  if(hCom)
    {
		if(TRUE!=WriteFile(
				hCom,							// handle of file to write to
				&datum,      			// address of data to write to file
				1,              	// number of bytes to write
				&bytes_written,	  // address of number of bytes written
				NULL))	 		 			// addr. of structure needed for overlapped I/O
			{
			printf("SendByte(): WriteFile() failed.\n");
			return;
			}
		if(bytes_written!=1)
			{
  		printf("SendByte(): only %d of %d bytes sent.\n",
						bytes_written,1);
			return;
			}
    }	
  else
  		printf("SendByte(): hCom in null.\n");

	}
//------------------------------------------------------------------------------
void SendString(char *data)
  {
  while(*data)
    SendByte(*data++);
  }
//------------------------------------------------------------------------------
